# 微信支付 API v3 Go SDK - merchantexclusivecoupon

No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

## 总览
本 SDK 由 WechatPay APIv3 SDK 生成器生成。生成器基于 [OpenAPI Generator](https://openapi-generator.tech) 构建。

- API 版本: 0.0.11

## 接口列表

所有URI均基于微信支付 API 地址：*https://api.mch.weixin.qq.com*

服务名 | 方法名 | HTTP 请求 | 描述
------------ | ------------- | ------------- | -------------
*BusiFavorApi* | [**CouponCodeInfo**](BusiFavorApi.md#couponcodeinfo) | **Get** /v3/marketing/busifavor/stocks/{stock_id}/couponcodes/{coupon_code} | 查询预存code详情
*BusiFavorApi* | [**CreateBusifavorStock**](BusiFavorApi.md#createbusifavorstock) | **Post** /v3/marketing/busifavor/stocks | 创建商家券
*BusiFavorApi* | [**DeleteCouponCode**](BusiFavorApi.md#deletecouponcode) | **Delete** /v3/marketing/busifavor/stocks/{stock_id}/couponcodes/{coupon_code} | 删除预存code
*BusiFavorApi* | [**ModifyBudget**](BusiFavorApi.md#modifybudget) | **Patch** /v3/marketing/busifavor/stocks/{stock_id}/budget | 修改批次预算
*BusiFavorApi* | [**ModifyStockInfo**](BusiFavorApi.md#modifystockinfo) | **Patch** /v3/marketing/busifavor/stocks/{stock_id} | 修改商家券基本信息
*BusiFavorApi* | [**QueryCouponCodeList**](BusiFavorApi.md#querycouponcodelist) | **Get** /v3/marketing/busifavor/stocks/{stock_id}/couponcodes | 查询预存code列表
*BusiFavorApi* | [**QueryStock**](BusiFavorApi.md#querystock) | **Get** /v3/marketing/busifavor/stocks/{stock_id} | 查询商家券批次详情
*BusiFavorApi* | [**UploadCouponCode**](BusiFavorApi.md#uploadcouponcode) | **Post** /v3/marketing/busifavor/stocks/{stock_id}/couponcodes | 上传预存code
*CallBackApi* | [**GetCouponNotify**](CallBackApi.md#getcouponnotify) | **Get** /v3/marketing/busifavor/callbacks | 获取商家券事件通知地址
*CallBackApi* | [**SetCouponNotify**](CallBackApi.md#setcouponnotify) | **Post** /v3/marketing/busifavor/callbacks | 设置商家券事件通知地址
*CouponApi* | [**AssociateTradeInfo**](CouponApi.md#associatetradeinfo) | **Post** /v3/marketing/busifavor/coupons/associate | 关联订单信息
*CouponApi* | [**DeactivateCoupon**](CouponApi.md#deactivatecoupon) | **Post** /v3/marketing/busifavor/coupons/deactivate | 使券失效
*CouponApi* | [**DisassociateTradeInfo**](CouponApi.md#disassociatetradeinfo) | **Post** /v3/marketing/busifavor/coupons/disassociate | 取消关联订单信息
*CouponApi* | [**ListCouponsByFilter**](CouponApi.md#listcouponsbyfilter) | **Get** /v3/marketing/busifavor/users/{openid}/coupons | 根据过滤条件查询用户的券
*CouponApi* | [**QueryCoupon**](CouponApi.md#querycoupon) | **Get** /v3/marketing/busifavor/users/{openid}/coupons/{coupon_code}/appids/{appid} | 查询用户券详情
*CouponApi* | [**ReturnCoupon**](CouponApi.md#returncoupon) | **Post** /v3/marketing/busifavor/coupons/return | 申请退券
*CouponApi* | [**SendCoupon**](CouponApi.md#sendcoupon) | **Post** /v3/marketing/busifavor/coupons/send | 向用户发券
*CouponApi* | [**SendGovCard**](CouponApi.md#sendgovcard) | **Post** /v3/marketing/busifavor/coupons/{card_id}/send | 发放政府消费卡
*CouponApi* | [**UseCoupon**](CouponApi.md#usecoupon) | **Post** /v3/marketing/busifavor/coupons/use | 核销用户的券
*SubsidyApi* | [**PayReceiptInfo**](SubsidyApi.md#payreceiptinfo) | **Get** /v3/marketing/busifavor/subsidy/pay-receipts/{subsidy_receipt_id} | 查询商家券营销补差付款单详情
*SubsidyApi* | [**PayReceiptList**](SubsidyApi.md#payreceiptlist) | **Get** /v3/marketing/busifavor/subsidy/pay-receipts | 查询商家券营销补差付款单列表
*SubsidyApi* | [**ReturnReceiptInfo**](SubsidyApi.md#returnreceiptinfo) | **Get** /v3/marketing/busifavor/subsidy/return-receipts/{subsidy_return_receipt_id} | 查询商家券营销补差回退单详情
*SubsidyApi* | [**SubsidyPay**](SubsidyApi.md#subsidypay) | **Post** /v3/marketing/busifavor/subsidy/pay-receipts | 商家券营销补差付款
*SubsidyApi* | [**SubsidyReturn**](SubsidyApi.md#subsidyreturn) | **Post** /v3/marketing/busifavor/subsidy/return-receipts | 商家券营销补差回退


## 类型列表

 - [AssociateTradeInfoRequest](AssociateTradeInfoRequest.md)
 - [AssociateTradeInfoResponse](AssociateTradeInfoResponse.md)
 - [AvailableCurrentDayTime](AvailableCurrentDayTime.md)
 - [AvailableWeek](AvailableWeek.md)
 - [BusiFavorStockType](BusiFavorStockType.md)
 - [CodeDisplayMode](CodeDisplayMode.md)
 - [CouponCodeCount](CouponCodeCount.md)
 - [CouponCodeEntity](CouponCodeEntity.md)
 - [CouponCodeInfoRequest](CouponCodeInfoRequest.md)
 - [CouponCodeInfoResponse](CouponCodeInfoResponse.md)
 - [CouponCodeListResponse](CouponCodeListResponse.md)
 - [CouponCodeMode](CouponCodeMode.md)
 - [CouponCodeStatus](CouponCodeStatus.md)
 - [CouponEntity](CouponEntity.md)
 - [CouponListResponse](CouponListResponse.md)
 - [CouponSendGovCardRequest](CouponSendGovCardRequest.md)
 - [CouponSendGovCardResponse](CouponSendGovCardResponse.md)
 - [CouponStatus](CouponStatus.md)
 - [CouponUseMethod](CouponUseMethod.md)
 - [CouponUseRule](CouponUseRule.md)
 - [CreateBusiFavorStockRequest](CreateBusiFavorStockRequest.md)
 - [CreateBusiFavorStockResponse](CreateBusiFavorStockResponse.md)
 - [CustomEntrance](CustomEntrance.md)
 - [DeactivateCouponRequest](DeactivateCouponRequest.md)
 - [DeactivateCouponResponse](DeactivateCouponResponse.md)
 - [DeleteCouponCodeRequest](DeleteCouponCodeRequest.md)
 - [DeleteCouponCodeResponse](DeleteCouponCodeResponse.md)
 - [DisassociateTradeInfoRequest](DisassociateTradeInfoRequest.md)
 - [DisassociateTradeInfoResponse](DisassociateTradeInfoResponse.md)
 - [DiscountMsg](DiscountMsg.md)
 - [DisplayPatternInfo](DisplayPatternInfo.md)
 - [ExchangeMsg](ExchangeMsg.md)
 - [FavorAvailableTime](FavorAvailableTime.md)
 - [FinderInfo](FinderInfo.md)
 - [FixedValueStockMsg](FixedValueStockMsg.md)
 - [GetCouponNotifyRequest](GetCouponNotifyRequest.md)
 - [GetCouponNotifyResponse](GetCouponNotifyResponse.md)
 - [IrregularAvailableTime](IrregularAvailableTime.md)
 - [ListCouponsByFilterRequest](ListCouponsByFilterRequest.md)
 - [MiniAppInfo](MiniAppInfo.md)
 - [ModifyBudgetBody](ModifyBudgetBody.md)
 - [ModifyBudgetRequest](ModifyBudgetRequest.md)
 - [ModifyBudgetResponse](ModifyBudgetResponse.md)
 - [ModifyCouponUseRule](ModifyCouponUseRule.md)
 - [ModifyCustomEntrance](ModifyCustomEntrance.md)
 - [ModifyMiniAppInfo](ModifyMiniAppInfo.md)
 - [ModifyStockInfoBody](ModifyStockInfoBody.md)
 - [ModifyStockInfoRequest](ModifyStockInfoRequest.md)
 - [ModifyStockSendRule](ModifyStockSendRule.md)
 - [NotifyConfig](NotifyConfig.md)
 - [PayReceiptInfoRequest](PayReceiptInfoRequest.md)
 - [PayReceiptListRequest](PayReceiptListRequest.md)
 - [QueryCouponCodeListRequest](QueryCouponCodeListRequest.md)
 - [QueryCouponRequest](QueryCouponRequest.md)
 - [QueryStockRequest](QueryStockRequest.md)
 - [ReturnCouponRequest](ReturnCouponRequest.md)
 - [ReturnCouponResponse](ReturnCouponResponse.md)
 - [ReturnReceiptInfoRequest](ReturnReceiptInfoRequest.md)
 - [SendCount](SendCount.md)
 - [SendCouponRequest](SendCouponRequest.md)
 - [SendCouponResponse](SendCouponResponse.md)
 - [SendCouponResult](SendCouponResult.md)
 - [SendGovCardRequest](SendGovCardRequest.md)
 - [SetCouponNotifyRequest](SetCouponNotifyRequest.md)
 - [SetCouponNotifyResponse](SetCouponNotifyResponse.md)
 - [StockGetResponse](StockGetResponse.md)
 - [StockSendRule](StockSendRule.md)
 - [StockStatus](StockStatus.md)
 - [SubsidyPayReceipt](SubsidyPayReceipt.md)
 - [SubsidyPayReceiptFailReason](SubsidyPayReceiptFailReason.md)
 - [SubsidyPayReceiptListResponse](SubsidyPayReceiptListResponse.md)
 - [SubsidyPayReceiptStatus](SubsidyPayReceiptStatus.md)
 - [SubsidyPayRequest](SubsidyPayRequest.md)
 - [SubsidyReturnReceipt](SubsidyReturnReceipt.md)
 - [SubsidyReturnReceiptFailReason](SubsidyReturnReceiptFailReason.md)
 - [SubsidyReturnReceiptStatus](SubsidyReturnReceiptStatus.md)
 - [SubsidyReturnRequest](SubsidyReturnRequest.md)
 - [UploadCouponCodeBody](UploadCouponCodeBody.md)
 - [UploadCouponCodeFailReason](UploadCouponCodeFailReason.md)
 - [UploadCouponCodeRequest](UploadCouponCodeRequest.md)
 - [UploadCouponCodeResponse](UploadCouponCodeResponse.md)
 - [UseCouponRequest](UseCouponRequest.md)
 - [UseCouponResponse](UseCouponResponse.md)

